//---------------------------------------------------------------------------

#ifndef mainFormH
#define mainFormH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <ComCtrls.hpp>
//---------------------------------------------------------------------------
#include "patch.h"
//---------------------------------------------------------------------------
class TfMain : public TForm
{
__published:	// IDE-managed Components
	TPanel *Panel1;
	TLabel *Label1;
	TEdit *eDivisor;
	TButton *bSetDivisor;
	TLabel *Label4;
	TEdit *eDegreeU;
	TLabel *Label5;
	TEdit *eDegreeV;
	TButton *bSetDegree;
	TLabel *Label6;
	TPageControl *PageControl1;
	TTabSheet *TabSheet1;
	TTabSheet *TabSheet2;
	TMemo *mKnotsU;
	TButton *bSetKnotsU;
	TButton *bSetKnotsV;
	TMemo *mKnotsV;
	TLabel *lWeight;
	TCheckBox *cbAxes;
	TLabel *Label7;
	TLabel *Label8;
	TLabel *Label9;
	TLabel *Label10;
	TLabel *Label11;
	TLabel *Label12;
	TEdit *eHighlightU;
	TLabel *Label13;
	TEdit *eHighlightV;
	TButton *bSetHighLight;
	TLabel *Label3;
	TEdit *eHighlightW;
	TImage *iHighlight;
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall FormDestroy(TObject *Sender);
	void __fastcall FormMouseWheel(TObject *Sender, TShiftState Shift,
          int WheelDelta, TPoint &MousePos, bool &Handled);
	void __fastcall bSetDivisorClick(TObject *Sender);
	void __fastcall bSetDegreeClick(TObject *Sender);
	void __fastcall bSetKnotsUClick(TObject *Sender);
	void __fastcall bSetKnotsVClick(TObject *Sender);
	void __fastcall cbAxesClick(TObject *Sender);
	void __fastcall bSetHighLightClick(TObject *Sender);
	void __fastcall iHighlightMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall iHighlightMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
	void __fastcall iHighlightMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
private:	// User declarations
	TPanel *fRenderPanel;
	TMouseButton fMouseDown;
	TPoint fMousePos;
	TCursor fCursorXY, fCursorZ;
	double fAzimuth, fElevation;
	HGLRC fRendCont;
	HDC fDevCont;
	TPatch* fPatch;
	double fZoom;
	TPatch::TParam fHighlight;
	TMouseButton fHighlightMouseDown;
        TPatch::TIndex fActiveVertex;
	void drawSurface();
	void initializeOpenGl();
	void updateViewMatrix();
	void updateActiveVertex(int x, int y);
	void updateControls();
	void __fastcall RenderPanelMouseDown(TObject *Sender, TMouseButton Button,
		  TShiftState Shift, int X, int Y);
	void __fastcall RenderPanelMouseMove(TObject *Sender, TShiftState Shift, int X,
		  int Y);
	void __fastcall RenderPanelMouseUp(TObject *Sender, TMouseButton Button,
		  TShiftState Shift, int X, int Y);
	void __fastcall RenderPanelResize(TObject *Sender);
public:		// User declarations
	__fastcall TfMain(TComponent* Owner);
};

typedef void (TfMain::*TDrawCallback)();

class TRenderPanel : public TPanel {
private:
	TDrawCallback fCallback;
	TfMain *fCallbackOwner;
protected:
	virtual __fastcall void Paint();
public:
	__fastcall TRenderPanel(TComponent* AOwner, TfMain *CallbackOwner,
		TDrawCallback Callback);
};

//---------------------------------------------------------------------------
extern PACKAGE TfMain *fMain;
//---------------------------------------------------------------------------
#endif

